package org.codecop.natural.natstyle.pmd;

import java.util.List;
import java.util.Map;
import java.util.Set;

import net.sourceforge.pmd.PropertyDescriptor;
import net.sourceforge.pmd.Rule;
import net.sourceforge.pmd.RuleContext;
import net.sourceforge.pmd.RulePriority;
import net.sourceforge.pmd.lang.Language;
import net.sourceforge.pmd.lang.LanguageVersion;
import net.sourceforge.pmd.lang.ParserOptions;
import net.sourceforge.pmd.lang.ast.Node;

/**
 * Minimal implementation of a PMD Rule to create a report.
 */
public class NaturalRule implements Rule {

    private final String name;
    private final String ruleSetName;
    private final RulePriority priority;
    private final String externalInfoUrl;

    public NaturalRule(String name, String ruleSetName, RulePriority priority, String externalInfoUrl) {
        this.name = name;
        this.ruleSetName = ruleSetName;
        this.priority = priority;
        this.externalInfoUrl = externalInfoUrl;
    }

    @Override
    public void definePropertyDescriptor(PropertyDescriptor<?> propertyDescriptor) throws IllegalArgumentException {
    }

    @Override
    public PropertyDescriptor<?> getPropertyDescriptor(String propertyName) {
        return null;
    }

    @Override
    public List<PropertyDescriptor<?>> getPropertyDescriptors() {
        return null;
    }

    @Override
    public <T> T getProperty(PropertyDescriptor<T> propertyDescriptor) {
        return null;
    }

    @Override
    public <T> void setProperty(PropertyDescriptor<T> propertyDescriptor, T value) {
    }

    @Override
    public Map<PropertyDescriptor<?>, Object> getPropertiesByPropertyDescriptor() {
        return null;
    }

    @Override
    public boolean hasDescriptor(PropertyDescriptor<?> descriptor) {
        return false;
    }

    @Override
    public boolean usesDefaultValues() {
        return false;
    }

    @Override
    public void useDefaultValueFor(PropertyDescriptor<?> desc) {
    }

    @Override
    public Set<PropertyDescriptor<?>> ignoredProperties() {
        return null;
    }

    @Override
    public String dysfunctionReason() {
        return null;
    }

    @Override
    public Language getLanguage() {
        return null;
    }

    @Override
    public void setLanguage(Language language) {
    }

    @Override
    public LanguageVersion getMinimumLanguageVersion() {
        return null;
    }

    @Override
    public void setMinimumLanguageVersion(LanguageVersion minimumLanguageVersion) {
    }

    @Override
    public LanguageVersion getMaximumLanguageVersion() {
        return null;
    }

    @Override
    public void setMaximumLanguageVersion(LanguageVersion maximumLanguageVersion) {
    }

    @Override
    public boolean isDeprecated() {
        return false;
    }

    @Override
    public void setDeprecated(boolean deprecated) {
    }

    @Override
    public String getName() {
        return name;
    }

    @Override
    public void setName(@SuppressWarnings("unused") String name) {
        throw new UnsupportedOperationException("name is read-only");
    }

    @Override
    public String getSince() {
        return null;
    }

    @Override
    public void setSince(String since) {
    }

    @Override
    public String getRuleClass() {
        return null;
    }

    @Override
    public void setRuleClass(String ruleClass) {
    }

    @Override
    public String getRuleSetName() {
        return ruleSetName;
    }

    @Override
    public void setRuleSetName(@SuppressWarnings("unused") String name) {
        throw new UnsupportedOperationException("rulesetName is read-only");
    }

    @Override
    public String getMessage() {
        return null;
    }

    @Override
    public void setMessage(String message) {
    }

    @Override
    public String getDescription() {
        return null;
    }

    @Override
    public void setDescription(String description) {
    }

    @Override
    public List<String> getExamples() {
        return null;
    }

    @Override
    public void addExample(String example) {
    }

    @Override
    public String getExternalInfoUrl() {
        return externalInfoUrl;
    }

    @Override
    public void setExternalInfoUrl(String externalInfoUrl) {
        throw new UnsupportedOperationException("externalInfoUrl is read-only");
    }

    @Override
    public RulePriority getPriority() {
        return priority;
    }

    @Override
    public void setPriority(@SuppressWarnings("unused") RulePriority priority) {
        throw new UnsupportedOperationException("priority is read-only");
    }

    @Override
    public ParserOptions getParserOptions() {
        return null;
    }

    @Override
    public void setUsesDFA() {
    }

    @Override
    public boolean usesDFA() {
        return false;
    }

    @Override
    public void setUsesTypeResolution() {
    }

    @Override
    public boolean usesTypeResolution() {
        return false;
    }

    @Override
    public boolean usesRuleChain() {
        return false;
    }

    @Override
    public List<String> getRuleChainVisits() {
        return null;
    }

    @Override
    public void addRuleChainVisit(Class<? extends Node> nodeClass) {
    }

    @Override
    public void addRuleChainVisit(String astNodeName) {
    }

    @Override
    public void start(RuleContext ctx) {
    }

    @Override
    public void apply(List<? extends Node> nodes, RuleContext ctx) {
    }

    @Override
    public void end(RuleContext ctx) {
    }

}
