package com.softwareag.naturalone.natural.natstyle.check.src.parser;

import java.io.IOException;

import com.softwareag.naturalone.natural.natstyle.NATstyleCheckerParserImpl;

public class DumpAstAsXml extends NATstyleCheckerParserImpl {

    @Override
    public void initParameterList() {
        // no parameters
    }

    @Override
    public String run() {
        StringBuffer xmlOutput = new StringBuffer();

        String xmlFile = getInputFile().getName() + ".xml";
        try (XmlVisitor visitor = new XmlVisitor(xmlFile)) {

            getNaturalParser().getNaturalASTRoot().accept(visitor);

        } catch (IOException e) {
            setFatal(xmlOutput, "File error: " + e.getMessage());
        }

        return xmlOutput.toString();
    }

}