package com.softwareag.naturalone.natural.natstyle.check.src.source;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import com.softwareag.naturalone.natural.natstyle.NATstyleCheckerSourceImpl;

public class FindInv02 extends NATstyleCheckerSourceImpl {

    private Matcher subroutineName;

    @Override
    public void initParameterList() {
        subroutineName = Pattern.compile("SP_INVO2").matcher("");
    }

    @Override
    public String run() {
        StringBuffer xmlOutput = new StringBuffer();

        String[] lines = this.getSourcelines();
        for (int i = 0; i < lines.length; i++) {
            subroutineName.reset(lines[i]);
            if (subroutineName.find()) {
                setError(xmlOutput, i, "Found 'SP_INVO2'.");
            }
        }

        return xmlOutput.toString();
    }
}
